////////////////////////////////////////////////////////////////////////////////////
//
// Pgpb2Encode.cpp
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: Pgpb2Encode.cpp,v $
 * Revision 1.7  2001/01/20 07:40:17  syou
 * - Í̍ہAToACcABcc̃AhXDefault RecipientƂĈ悤ɂA
 *   ܂Cӂ̌JgĈÍł悤ɂB܂ADefault Recipient
 *   Default Private Key̒ǉ\ɂIvV݂BA
 *   ͂Ȃr(^^;
 *
 * Revision 1.6  2000/11/29 12:46:35  syou
 * - broken version line ̏CBsɂ܂Ă͖̂炩Ƀ~X
 *   łB
 *
 * Revision 1.5  2000/11/08 16:50:47  syou
 * - PGPlogɃbZ[Wo͂邽߂ɁAclass PGPlogVK쐬B
 *   FXKvɂȂ肻Ȃ̂ŁAclass CriticalSectionVK쐬B
 *
 * Revision 1.4  2000/11/07 15:57:19  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 * Revision 1.3  2000/08/24 15:39:24  syou
 * - multipart`̃[ƂsȏA؂ł
 * 肷̃oOCBBkCommon.cpp̉~XB
 *
 * Revision 1.2  2000/08/23 22:26:45  syou
 * - ̏I[s̃oOCBBkCommon.cppABkCommon.hőΏB
 *
 * Revision 1.1  2000/08/06 15:14:42  syou
 * - message/rfc822`Ń[YtĂꍇAYtĂ郁[
 *   ǂ̑ΏۂƂȂ悤ɂBB2(beta23)ȍ~ep[g Content-Typew
 *   ƎQƂ邱ƂmFBAbeta22ȑOgč쐬ꂽ
 *   multipart[̏ꍇ́Â肭Ȃ悤ɎvB
 *   main.cpp剻߁ABclass CPgpb2ǉA
 *   Pgpb2Decode.cppAPgpb2Encode.cppAPgpb2Utility.cppɕčsB
 *   剻ABkmail2->h𕪊Bclass`BkMessage.hɏWA
 *   class CBkMessagẽCC֐BkMessage.hɁAclass CBkMailPart̃C
 *   C֐BkMailPart.hɁAclass CBkMail̃CC֐Bkmail2->hɋL
 *   qA#includeɂABkMessage.h̖Ɏ荞łB
 *   ȊÓAꂼBkMessage.cppABkMailPart.cppABkmail2->cppɎB
 *   message/rfc822`̓Yt[ɑΉ邽߁A class CBkRfc822ǉBC
 *   C֐ BkRfc822.hɋLqȂBkRfc822.cppɎBclass
 *   CBkMessage̔hNXÂNXłclass
 *   CBkMessageɈϏB
 *   Encodẽ[`̕ADecodê̂ɓB܂A
 *         CBkMailPartPtr bmpEncrypt1;
 *         bmpEncrypt1 = mail2->SetChild(new CMIMEItem());
 *
 */


#pragma warning(push)
#pragma warning(disable:4101)
#pragma warning(disable:4786)


////////////////////////////////////////////////////////////////////////
//
#include "Pgpb2.h"
#include "stringfr.h"


////////////////////////////////////////////////////////////////////////
// PGPÍ
bool Pgpb2::encrypt(HWND hWnd, PgpMail* mail)
{
    // 
    bool result = false;

    // Config擾
    config = b2apiex->GetConfig();

    // "To"A"Cc"A"Bcc"̊ewb_ mailaddress 𒊏oA|C^XgɊi[B
    string to;
    string cc;
    string bcc;

    if (mail->getHeader("Resent-Message-Id").length()) {
        to = mail->getHeader("Resent-To");
        cc = mail->getHeader("Resent-Cc");
        bcc = mail->getHeader("Resent-Bcc");
    }else {
        to = mail->getHeader("To");
        cc = mail->getHeader("Cc");
        bcc = mail->getHeader("Bcc");
    }

    CPointerList lstAddr;
    addAddressList(lstAddr, to);
    addAddressList(lstAddr, cc);
    addAddressList(lstAddr, bcc);

    // i[ mailaddress Ƃ return B
    CPointerItem* pItem = lstAddr.GetTop();
    if (pItem == NULL) {
        return result;
    }

    // ǉƂāADefault KeySet擾
    PGPKeySetRef defaultKeySet = kInvalidPGPKeySetRef;
    PGPKeySetRef foundUserKeySet = kInvalidPGPKeySetRef;
    PGPKeySetRef encryptKeySet = kInvalidPGPKeySetRef;
    PGPRecipientSpec *spec = NULL;
    LPSTR lpArea = NULL;

    try {
        // Default Key RingJ
        PGPError err = PGPOpenDefaultKeyRings(context, kPGPKeyRingOpenFlags_Mutable, &defaultKeySet);
        if (IsPGPError(err)) {
            throw PGPSdkError(err, "The error occured in PGPOpenDefaultKeyRings.");
        }

        // e mailaddress ɑΉL[܂Ƃ߂Ēo
        getKeySet(pItem, defaultKeySet, foundUserKeySet);

        // Default Recipient擾
        int numberOfDefault = getDefaultRecipients(foundUserKeySet, spec);
        if (numberOfDefault == 0) {
            throw PGPUserError("Not found any key of recipients in Default Key Ring");
        }

        // ÍɎgpL[I_CAO\B
        PGPUInt32 initialValueOfPgpMime = (pgpmime) ? TRUE : FALSE;
        PGPUInt32 resultValueOfPgpMime;

        err = PGPRecipientDialog(
                context,
                defaultKeySet,
                TRUE,
                &encryptKeySet,
                PGPOUIParentWindowHandle(context, hWnd),
                PGPOUIDialogOptions(context,
                    PGPOUICheckbox(context, 1, "PGP/MIME_RFC2015", NULL,
                        initialValueOfPgpMime, &resultValueOfPgpMime,
                        PGPOLastOption(context)),
                    /*
                    PGPOUICheckbox(context, 2, "Conventional Encryption", NULL,
                        initialValueOfConv, &resultValueOfConv,
                        PGPOLastOption(context)),
                    */
                    PGPOLastOption(context)),
                //PGPOUIDisplayMarginalValidity(context, TRUE),
                PGPOUIDefaultRecipients(context, numberOfDefault, spec),
                PGPOLastOption(context)
                );

        if (err == kPGPError_UserAbort) {
            throw PGPUserError("User Canceled.");
        } else if (IsPGPError(err)) {
            throw PGPSdkError(err, "The error occured in PGPRecipientDialog.");
        }

        PGPUInt32 count;
        err = PGPCountKeys(encryptKeySet, &count);
        if (IsPGPError(err)) {
            throw PGPSdkError(err, "The error occured in PGPCountKeys.");
        } else if ( count < 1) {
            throw PGPUserError("User didn't select any Recipients.");
        }

        pgpmime = (resultValueOfPgpMime == TRUE);
        string text = mail->getPgpOriginalText(hWnd, pgpmime);
        if (text.size() == 0) {
            throw PGPUserError("User's mail don't have text");
        }

        /* Debug code
        FILE* fp;
        fp = fopen("E:\\syou\\mail1.txt", "wb");
        fwrite(text.c_str(), text.size(), 1, fp);
        fclose(fp);
        //*/

        PGPSize size;
        err = PGPEncode(
                context,
                PGPOEncryptToKeySet(context, encryptKeySet),
                PGPOInputBuffer(context, text.c_str(), text.size()),
                PGPOAllocatedOutputBuffer(context, reinterpret_cast<void**>(&lpArea), MAX_PGPInt32, &size),
                PGPOVersionString(context, mes->getsfr(33).c_str()),
                PGPOArmorOutput(context, TRUE),
                PGPOLastOption(context)
                );

        if (IsPGPError(err) || lpArea == NULL) {
            throw PGPSdkError(err, "The error occured in PGPEncode.");
        }

        if (pgpmime) {
            char szBoundary[1024];  // MIMEboundary ؂蕶
            char szData[8192];
            time_t t;
            time(&t);   // ݂̎擾 boundaryɖߍ
            sprintf(szBoundary, "===[PGP/MIME_RFC2015]===%08X.%04X===", (DWORD)t, &t);
            sprintf(szData, "multipart/encrypted;\r\n boundary=\"%s\";\r\n protocol=\"application/pgp-encrypted\"", szBoundary);
            mail->setHeader("Content-Type", szData);
            mail->setHeader("Content-Transfer-Encoding", "7bit");
            mail->clearBody();

            BkMail* child1 = mail->setChild(new BkMail());
            child1->setHeader("Content-Type", "application/pgp-encrypted");
            child1->setHeader("Content-Transfer-Encoding", "7bit");
            child1->pushBodyBack("Version: 1\r\n");

            BkMail* child2 = mail->addChild(new BkMail());
            child2->setHeader("Content-Type", "application/octet-stream");
            child2->setHeader("Content-Transfer-Encoding", "7bit");
            child2->pushBodyBack(lpArea);
        }
        else {
            mail->setText(lpArea);
        }

        result = true;

    } catch (PGPSdkError& sdkError) {
        std::string message = sdkError.getErrorSpecification();
        ::MessageBox(hWnd, message.c_str(), "PGPB2 - Error", MB_OK | MB_ICONERROR);
    } catch (PGPUserError& userError) {
        b2api->SetMessageText(hWnd, userError.what());
    }

    // Clean up
    if (PGPKeySetRefIsValid(encryptKeySet)){
        PGPFreeKeySet(encryptKeySet);
    }
    if (PGPKeySetRefIsValid(defaultKeySet)) {
        PGPFreeKeySet(defaultKeySet);
    }
    if (lpArea) {
        PGPFreeData(lpArea);
    }
    if (spec) {
        delete spec;
    }

    return result;
}


////////////////////////////////////////////////////////////////////////
// PGP
bool Pgpb2::signing(HWND hWnd, PgpMail* mail)
{
    // 
    bool result = false;

    // Config擾
    config = b2apiex->GetConfig();

    // "From"wb_ mailaddress 𒊏oA|C^XgɊi[
    string from;
    if (mail->getHeader("Resent-Message-Id").length()) {
        from = mail->getHeader("Resent-From");
    } else {
        from = mail->getHeader("From");
    }

    CPointerList lstAddr;
    addAddressList(lstAddr, from);

    // i[ mailaddress Ƃ return
    CPointerItem* pItem = lstAddr.GetTop();
    if (pItem == NULL) {
        return false;
    }

    // Clean upKvȂ̂`
    PGPKeySetRef defaultKeySet = kInvalidPGPKeySetRef;
    PGPKeySetRef foundUserKeySet = kInvalidPGPKeySetRef;
    PGPOptionListRef encodeOptionList = kInvalidPGPOptionListRef;
    PGPKeyRef signingKey = kInvalidPGPKeyRef;
    char *lpPassphrase = NULL;
    LPSTR lpArea = NULL;

    try {
        // Default Key RingJ
        PGPError err = PGPOpenDefaultKeyRings(context, kPGPKeyRingOpenFlags_Mutable, &defaultKeySet);
        if (IsPGPError(err)) {
            throw PGPSdkError(err, "The Error occured in PGPOpenDefaultKeyRings.");
        }

        // e mailaddress ɑΉL[܂Ƃ߂Ēo
        getKeySet(pItem, defaultKeySet, foundUserKeySet);

        if (!getPassphraseFromSignCache(foundUserKeySet, signingKey, lpPassphrase)) {

            PGPKeyRef signDefaultKey = NULL;
            getKeyRef(foundUserKeySet, signDefaultKey);

            // Passphrase ͂_CAO\
            PGPUInt32 initialValueOfPgpMime = (pgpmime) ? TRUE : FALSE;
            PGPUInt32 resultValueOfPgpMime;

            err = PGPSigningPassphraseDialog(
                    context,
                    defaultKeySet,
                    &signingKey,
                    PGPOUIOutputPassphrase(context, &lpPassphrase),
                    PGPOUIParentWindowHandle(context, hWnd),
                    PGPOUIVerifyPassphrase(context, TRUE),
                    PGPOUIDialogOptions(context,
                        PGPOUICheckbox(context, 1, "PGP/MIME_RFC2015", NULL, initialValueOfPgpMime, &resultValueOfPgpMime,
                            PGPOLastOption(context)),
                        PGPOLastOption(context)),
                    PGPOUIDefaultKey(context, signDefaultKey),
                    PGPOLastOption(context)
                    );

            if (err == kPGPError_UserAbort) {
                throw PGPUserError("User Canceled");
            } else if (IsPGPError(err)) {
                throw PGPSdkError(err, "The Error occured in SigningPassphraseDialog.");
            }

            pgpmime = (resultValueOfPgpMime == TRUE);
        }

        string text = mail->getPgpOriginalText(hWnd, pgpmime);
        if (text.size() == 0) {
            throw PGPUserError("User's mail don't have text.");
        }

        /*
            FILE* fp;
            fp = fopen("E:\\syou\\mail1.txt", "wb");
            fwrite(text.c_str(), text.size(), 1, fp);
            fclose(fp);
        //*/

        PGPSize outputSize = 0;
        err = PGPBuildOptionList(
                context,
                &encodeOptionList,
                PGPOInputBuffer(context, text.c_str(), text.size()),
                PGPOAllocatedOutputBuffer(context, reinterpret_cast<void**>(&lpArea), MAX_PGPInt32, &outputSize),
                PGPOVersionString(context, mes->getsfr(33).c_str()),
                    PGPOSignWithKey(context, signingKey,
                        PGPOPassphrase(context, lpPassphrase),
                        PGPOLastOption(context)),
                PGPOLastOption(context)
                );

        if (IsPGPError(err)) {
            throw PGPSdkError(err, "The Error occured in BuildOptionList.");
        }

        if (pgpmime) {
            err = PGPAppendOptionList(
                    encodeOptionList,
                    PGPOArmorOutput(context, TRUE),
                    PGPODetachedSig(context,
                        PGPOLastOption(context)),
                    PGPOLastOption(context)
                    );
        }
        else {
            err = PGPAppendOptionList(
                    encodeOptionList,
                    PGPOClearSign(context, TRUE),
                    PGPOLastOption(context)
                    );
        }

        if (IsPGPError(err)) {
            throw PGPSdkError(err, "The Error occured in BuildOptionList.");
        }

        err = PGPEncode(context, encodeOptionList, PGPOLastOption(context));

        if (IsPGPError(err) || lpArea == NULL) {
            throw PGPSdkError(err, "The Error occured in Encode.");
        }

        if (pgpmime) {
            char szBoundary[1024];
            char szData[8192];
            char szHash[20];
            time_t t;

            if (!getHashAlgorithm(signingKey, szHash)) {
                throw PGPSdkError(err, "The Error occured in getHashAlgorithm.");
            }

            time(&t);
            sprintf(szBoundary, "===[PGP/MIME_RFC2015]===%08X.%04X===", (DWORD)t, &t);
            sprintf(szData, "multipart/signed;\r\n boundary=\"%s\";\r\n protocol=\"application/pgp-signature\"; micalg=pgp-%s",
                szBoundary, szHash);
            mail->setHeader("Content-Type", szData);
            mail->setHeader("Content-Transfer-Encoding", "7bit");
            mail->clearBody();

            BkMail* child1 = mail->setChild(new BkMail());
            child1->fromString(text);

            BkMail* child2 = mail->addChild(new BkMail());
            child2->setHeader("Content-Type", "application/pgp-signature");
            child2->setHeader("Content-Transfer-Encoding", "7bit");
            child2->pushBodyBack(lpArea);
        }
        else {
            mail->setText(lpArea);
        }

        result = true;

    } catch (PGPSdkError& sdkError) {
        std::string message = sdkError.getErrorSpecification();
        ::MessageBox(hWnd, message.c_str(), "PGPB2 - Error", MB_OK | MB_ICONERROR);
    } catch (PGPUserError& userError) {
        b2api->SetMessageText(hWnd, userError.what());
    }

    // Save passphrase for sign
    if (lpPassphrase) {
        cache->setSignPassphrase(signingKey, lpPassphrase);
    }

    // Clean up
    if (lpArea) {
        PGPFreeData(lpArea);
    }
    if (PGPOptionListRefIsValid(encodeOptionList)) {
        PGPFreeOptionList(encodeOptionList);
    }
    if (PGPKeySetRefIsValid(foundUserKeySet)) {
        PGPFreeKeySet(foundUserKeySet);
    }
    if (PGPKeySetRefIsValid(defaultKeySet)) {
        PGPFreeKeySet(defaultKeySet);
    }

    return result;
}



////////////////////////////////////////////////////////////////////////
// PGPÍ
bool Pgpb2::encryptSigning(HWND hWnd, PgpMail* mail)
{
    // 
    bool result = false;

    // Config擾
    config = b2apiex->GetConfig();

    // "To"A"Cc"A"Bcc"̊ewb_ mailaddress 𒊏oA|C^XgɊi[B
    string to;
    string cc;
    string bcc;
    string from;

    if (mail->getHeader("Resent-Message-Id").length()) {
        to = mail->getHeader("Resent-To");
        cc = mail->getHeader("Resent-Cc");
        bcc = mail->getHeader("Resent-Bcc");
        from = mail->getHeader("Resent-From");
    }else {
        to = mail->getHeader("To");
        cc = mail->getHeader("Cc");
        bcc = mail->getHeader("Bcc");
        from = mail->getHeader("From");
    }

    CPointerList lstToAddr;
    CPointerList lstFromAddr;
    addAddressList(lstToAddr, to);
    addAddressList(lstToAddr, cc);
    addAddressList(lstToAddr, bcc);
    addAddressList(lstFromAddr, from);

    CPointerItem* pToItem = lstToAddr.GetTop();
    CPointerItem* pFromItem = lstFromAddr.GetTop();
    if (pToItem == NULL || pFromItem == NULL) {
        return false;
    }

    PGPKeySetRef defaultKeySet = kInvalidPGPKeySetRef;
    PGPKeySetRef foundToUserKeySet = kInvalidPGPKeySetRef;
    PGPKeySetRef foundFromUserKeySet = kInvalidPGPKeySetRef;
    PGPKeySetRef encryptKeySet = kInvalidPGPKeySetRef;
    PGPKeyRef signingKey = kInvalidPGPKeyRef;
    PGPRecipientSpec *spec = NULL;
    LPSTR lpPassphrase = NULL;
    LPSTR lpArea = NULL;

    try {
        // ǉƂāADefault KeySet擾
        PGPError err = PGPOpenDefaultKeyRings(context, kPGPKeyRingOpenFlags_Mutable, &defaultKeySet);
        if (IsPGPError(err)) {
            throw PGPSdkError(err, "The Error occured in OpenDefaultKeyRings.");
        }

        getKeySet(pToItem, defaultKeySet, foundToUserKeySet);
        getKeySet(pFromItem, defaultKeySet, foundFromUserKeySet);

        // Default Recipient擾
        int numberOfDefault = getDefaultRecipients(foundToUserKeySet, spec);
        if (numberOfDefault == 0) {
            throw PGPUserError("Not found any key of recipients in Default Key Ring.");
        }

        PGPUInt32 initialValueOfPgpMime = (pgpmime) ? TRUE : FALSE;
        PGPUInt32 resultValueOfPgpMime;
        err = PGPRecipientDialog(
                context,
                defaultKeySet,
                TRUE,
                &encryptKeySet,
                PGPOUIParentWindowHandle(context, hWnd),
                PGPOUIDialogOptions(context,
                    PGPOUICheckbox(context, 1, "PGP/MIME_RFC2015", NULL, initialValueOfPgpMime, &resultValueOfPgpMime,
                        PGPOLastOption(context)),
                    PGPOLastOption(context)),
                PGPOUIDefaultRecipients(context, numberOfDefault, spec),
                PGPOLastOption(context)
                );


        if (err == kPGPError_UserAbort) {
            throw PGPUserError("User Canceled.");
        } else if (IsPGPError(err)) {
            throw PGPSdkError(err, "The Error occured in RecipientDialog.");
        }

        pgpmime = (resultValueOfPgpMime == TRUE);

        if (!getPassphraseFromSignCache(foundFromUserKeySet, signingKey, lpPassphrase)) {

            PGPKeyRef signDefaultKey = NULL;
            getKeyRef(foundFromUserKeySet, signDefaultKey);

            err = PGPSigningPassphraseDialog(
                    context,
                    defaultKeySet,
                    &signingKey,
                    PGPOUIOutputPassphrase(context, &lpPassphrase),
                    PGPOUIParentWindowHandle(context, hWnd),
                    PGPOUIVerifyPassphrase(context, TRUE),
                    PGPOUIDefaultKey(context, signDefaultKey),
                    PGPOLastOption(context)
                    );

            if (err == kPGPError_UserAbort) {
                throw PGPUserError("User Canceled.");
            } else if (IsPGPError(err)) {
                throw PGPSdkError(err, "The Error occured in SigningPassphraseDialog.");
            }
        }

        string text = mail->getPgpOriginalText(hWnd, pgpmime);
        if (text.size() == 0) {
            throw PGPUserError("User's mail don't have text.");
        }

        PGPSize outputSize = 0;
        err = PGPEncode(
                context,
                PGPOInputBuffer(context, text.c_str(), text.size()),
                PGPOAllocatedOutputBuffer(context, reinterpret_cast<void**>(&lpArea), MAX_PGPInt32, &outputSize),
                PGPOVersionString(context, mes->getsfr(33).c_str()),
                PGPOEncryptToKeySet(context, encryptKeySet),
                PGPOSignWithKey(context, signingKey,
                    PGPOPassphrase(context, lpPassphrase),
                    PGPOLastOption(context)),
                PGPOArmorOutput(context, TRUE),
                PGPOLastOption(context)
                );

        if (IsPGPError(err) || lpArea == NULL) {
            throw PGPSdkError(err, "The Error occured in Encode.");
        }

        if (pgpmime) {
            char szBoundary[1024];  // MIMEboundary ؂蕶
            char szData[8192];
            time_t t;
            time(&t);   // ݂̎擾 boundaryɖߍ
            sprintf(szBoundary, "===[PGP/MIME_RFC2015]===%08X.%04X===", (DWORD)t, &t);
            sprintf(szData, "multipart/encrypted;\r\n boundary=\"%s\";\r\n protocol=\"application/pgp-encrypted\"", szBoundary);
            mail->setHeader("Content-Type", szData);
            mail->setHeader("Content-Transfer-Encoding", "7bit");
            mail->clearBody();

            BkMail* child1;
            child1 = mail->setChild(new BkMail());
            child1->setHeader("Content-Type", "application/pgp-encrypted");
            child1->setHeader("Content-Transfer-Encoding", "7bit");
            child1->pushBodyBack("Version: 1\r\n");

            BkMail* child2;
            child2 = mail->addChild(new BkMail());
            child2->setHeader("Content-Type", "application/octet-stream");
            child2->setHeader("Content-Transfer-Encoding", "7bit");
            child2->pushBodyBack(lpArea);
        }
        else {
            mail->setText(lpArea);
        }

        result = true;

    } catch (PGPSdkError& sdkError) {
        std::string message = sdkError.getErrorSpecification();
        ::MessageBox(hWnd, message.c_str(), "PGPB2 - Error", MB_OK | MB_ICONERROR);
    } catch (PGPUserError& userError) {
        b2api->SetMessageText(hWnd, userError.what());
    }

    // Save passphrase for sign
    if (lpPassphrase) {
        cache->setSignPassphrase(signingKey, lpPassphrase);
    }

    // Clean up
    if (lpArea) {
        PGPFreeData(lpArea);
    }
    if (PGPKeySetRefIsValid(encryptKeySet)) {
        PGPFreeKeySet(encryptKeySet);
    }
    if (PGPKeySetRefIsValid(foundFromUserKeySet)) {
        PGPFreeKeySet(foundFromUserKeySet);
    }
    if (PGPKeySetRefIsValid(foundToUserKeySet)) {
        PGPFreeKeySet(foundToUserKeySet);
    }
    if (PGPKeySetRefIsValid(defaultKeySet)) {
        PGPFreeKeySet(defaultKeySet);
    }
    if (spec) {
        delete spec;
    }

    return result;
}


////////////////////////////////////////////////////////////////////////
// PGPJYt
bool Pgpb2::publickey(HWND hWnd)
{
    bool result = false;

    // Config擾
    config = b2apiex->GetConfig();

    PGPKeySetRef defaultKeySet = kInvalidPGPKeySetRef;
    PGPKeySetRef attachementKeySet = kInvalidPGPKeySetRef;
    PGPFileSpecRef fileSpec = kInvalidPGPFileSpecRef;

    try {
        PGPError err = PGPOpenDefaultKeyRings(context, kPGPKeyRingOpenFlags_Mutable, &defaultKeySet);
        if (IsPGPError(err)) {
            throw PGPSdkError(err, "The error occured in PGPOpenDefaultKeyRings.");
        }

        err = PGPRecipientDialog(
                context,
                defaultKeySet,
                TRUE,
                &attachementKeySet,
                PGPOUIParentWindowHandle(context, hWnd),
                PGPOLastOption(context)
                );

        if (err == kPGPError_UserAbort) {
            throw PGPUserError("User Canceled.");
        } else if (IsPGPError(err)) {
            throw PGPSdkError(err, "The Error occured in PGPRecipientDialog.");
        }

        std::string fullpath;
        fullpath = b2api->GetTempFolder();
        fullpath += getExportKeySetFileName(attachementKeySet);

        err = PGPNewFileSpecFromFullPath(context, fullpath.c_str(), &fileSpec);
        if (IsPGPError(err)) {
            throw PGPSdkError(err, "The Error occured in PGPNewFileSpecFromFullPath.");
        }

        PGPExportFormat exportformat = kPGPExportFormat_Basic;
        PGPSize outputSize = 0;
        err = PGPExportKeySet(
                  attachementKeySet,
                  PGPOOutputFile(context, fileSpec),
                  PGPOExportFormat(context, exportformat),
                  PGPOVersionString(context, mes->getsfr(33).c_str()),
                  PGPOExportPrivateKeys(context, FALSE),
                  PGPOLastOption(context)
                  );

        /*
        char* msg = new char[1024];
        PGPGetErrorString(err, 1024, msg);
        delete [] msg;
        */

        if (IsPGPError(err)) {
            throw PGPSdkError(err, "The Error occured in ExportKeySet.");
        }

        b2api->CompAttachFile(hWnd, fullpath.c_str(), "application/pgp-keys;");
        ::DeleteFile(fullpath.c_str());

        result = true;

    } catch (PGPSdkError& sdkError) {
        std::string message = sdkError.getErrorSpecification();
        ::MessageBox(hWnd, message.c_str(), "PGPB2 - Error", MB_OK | MB_ICONERROR);
    } catch (PGPUserError& userError) {
        b2api->SetMessageText(hWnd, userError.what());
    }

    // Clean up
    if (PGPFileSpecRefIsValid(fileSpec)) {
        PGPFreeFileSpec(fileSpec);
    }
    if (PGPKeySetRefIsValid(attachementKeySet)) {
        PGPFreeKeySet(attachementKeySet);
    }
    if (PGPKeySetRefIsValid(defaultKeySet)) {
        PGPFreeKeySet(defaultKeySet);
    }

    return result;
}

#pragma warning(pop) /* restore previous warning */
